Imports System.Math
Imports System.Drawing.Drawing2D

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Name = "Form1"
        Me.Text = "Scales"

    End Sub

#End Region

    Private m_InverseTransformation As Matrix

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        ' Set viewport (-10, -10) to (110, 110).
        Dim gr As Graphics = e.Graphics
        SetScale(gr, Me.ClientSize.Width, Me.ClientSize.Height, _
            -10, 110, 110, -10)

        ' Save the inverted transformation matrix.
        m_InverseTransformation = gr.Transform
        m_InverseTransformation.Invert()

        ' Draw coordinate axes.
        ' make a pen for the axes. 
        ' (Width 0 means a fine line.)
        Dim red_pen As Pen = New Pen(Color.Red, 0)
        gr.DrawLine(red_pen, -5, 0, 105, 0)
        For x As Integer = 10 To 100 Step 10
            gr.DrawLine(red_pen, x, -3, x, 3)
        Next x
        gr.DrawLine(red_pen, 0, -5, 0, 105)
        For y As Integer = 10 To 100 Step 10
            gr.DrawLine(red_pen, -3, y, 3, y)
        Next y

        ' Put circles in the corners.
        gr.FillEllipse(Brushes.Cyan, -10, 110, 3, -3)
        gr.DrawEllipse(red_pen, -10, 110, 3, -3)
        gr.FillEllipse(Brushes.Yellow, -10, -10, 3, 3)
        gr.DrawEllipse(red_pen, -10, -10, 3, 3)
        gr.FillEllipse(Brushes.White, 110, -10, -3, 3)
        gr.DrawEllipse(red_pen, 110, -10, -3, 3)
        gr.FillEllipse(Brushes.PaleGreen, 110, 110, -3, -3)
        gr.DrawEllipse(red_pen, 110, 110, -3, -3)

        ' Draw
        Dim black_pen As Pen = New Pen(Color.Black, 0)
        Dim y0 As Single = F(0)
        For x As Single = 0 To 100
            gr.DrawLine(black_pen, x - 1, y0, x, F(x))
            y0 = F(x)
        Next x
    End Sub

    ' Set transformations for the Graphics object
    ' so its coordinate system matches the one specified.
    ' Return the horizontal scale.
    Private Sub SetScale(ByVal gr As Graphics, ByVal gr_width As Integer, ByVal gr_height As Integer, ByVal left_x As Single, ByVal right_x As Single, ByVal top_y As Single, ByVal bottom_y As Single)
        ' Start from scratch.
        gr.ResetTransform()

        ' Scale so the viewport's width and height
        ' map to the Graphics object's width and height.
        Dim bounds As RectangleF = gr.ClipBounds
        gr.ScaleTransform( _
            gr_width / (right_x - left_x), _
            gr_height / (bottom_y - top_y))

        ' Translate (left_x, top_y) to the Graphics
        ' object's origin.
        gr.TranslateTransform(-left_x, -top_y)
    End Sub

    ' The function we are graphing.
    Private Function F(ByVal x As Single) As Single
        Return 50 + 45 * (Sin(x / 3) + Sin(x / 7)) / 2
    End Function

    ' Display the mouse's coordinates.
    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        ' Apply the inverted transformation to the point.
        Dim ptfs() As PointF = {New PointF(e.X, e.Y)}
        m_InverseTransformation.TransformPoints(ptfs)

        ' Display the result.
        Me.Text = "Scales (" & _
            ptfs(0).X.ToString("0.0") & ", " & _
            ptfs(0).Y.ToString("0.0") & ")"
    End Sub
End Class
